typedef struct {
  float x;
  float y;
  float dir;
  float head_angle;
} pos_t;

typedef struct {
  int time;
  float x;
  float y;
  float dir;
  float v;
} obj_info_t;

typedef struct {
  int time;
  rc_view_quality_t view_mode_quality;
  rc_view_width view_mode_width;
  float stamina;
  float effort;
  float speed;
  int kick_count;
  int dash_count;
  int turn_count;
  int say_count;
  int turn_neck_count;
} sense_body_t;

typedef enum { ERROR, SEE, MESSAGE, REFEREE, SENSE_BODY } percept_t;

typedef struct {
  void* my_goal; /* Unknown type (for the moment) */

  void* enemy_goal; /* Unknown type (for the moment) */

  obj_info_t ball_pos; /* Represent the position of the ball */

  /* Position of the other players of my team. To use the number
     of the shirt the size of the array is 12. */
  obj_info_t team_players[12];

  /* Position of the players of the oter team. To use the number
     of the shirt the size of the array is 12. */
  obj_info_t enemy_players[12];
   
  /* Type of the last perception: can be SEE, MESSAGE, REFEREE,
     SENSE-BODY or ERROR. */
  percept_t last-percept-type;

  ;; Contains the last message of the referee. In fact contains the
  ;; state of the game
  last-referee-msg 

  ;; last-message-read
  last-message-read

  ;; Name of the team
  team
   
  ;; Last message heard
  last-msg

  ;; Contains the current side of the team.
  side

  ;; evt??? I don't know why this attribute exists.
  msg-buf

  ;; Position of the player
  player-pos

  ;; Status of the player
  (sense-body-info (make-sense-body))

  ;; Throw ball?
  goalie-fire
  
  ;; For the moment is unused
  history

  ;; Seen ball dir
  last-ball-dir

  ;; Seen ball dist
  last-ball-dist

  ;; Front players
  (front-players 0)

  ;; Left players
  left-players

  ;; Right players
  right-players)
} agent_kb_t;
