;;;; parser.lsp
;;;; @author Source automatically generated by c2ecl
;;;;
;;;; Changes:
;;;;

(clines "
/*******************************************

 *******************************************/

#include <ctype.h>
#include <stdio.h>
/* File parser.h included by the generator c2ecl */

#ifndef __PARSER_H__
#define __PARSER_H__

#define MAX_TEAMNAME_LEN 20
#define MAX_MSG_LEN      512
#define INVALID_VALUE    65536
#define SELF_DIR         65537
#define REFEREE_DIR      65538

#define READ_NUM(dest) { \\
	int afterdot = 0, power = 1, sign = 1; \\
        dest = 0; \\
\\
	if (*input == '-') { \\
	  sign = -1; \\
	  ++input; \\
	} \\
\\
	while (isdigit(*input) || (*input == '.')) { \\
	  if (*input == '.') \\
	    afterdot = 1; \\
	  else { \\
	    if (afterdot) power *= 10; \\
	    dest = (dest * 10) + (*input - '0'); \\
	  } \\
\\
	  ++input; \\
	} \\
\\
        dest *= sign; \\
	if (power > 1) \\
	  dest /= power; \\
      }

#define READ_INT(dest) dest = 0; \\
  while (isdigit(*input)) \\
    dest = (dest * 10) + (*input++ - '0');

typedef enum { OK, INTERNAL_ERROR, UNKNOWN_PERCEPT } rc_result_t;
typedef enum { OBJ_PLAYER, OBJ_GOAL, OBJ_BALL, OBJ_LINE, OBJ_FLAG } rc_obj_t;
typedef enum { S_UNKNOWN, S_BEFORE_KICK_OFF, S_KICK_OFF, S_KICK_IN,
	       S_CORNER_KICK, S_OFFSIDE, S_GOAL_KICK, S_FREE_KICK, 
	       S_PLAY_ON, S_HALF_TIME, S_TIME_UP, S_EXTEND, S_FOUL,
	       S_GOAL } rc_state_t;
typedef enum { VQ_HIGH, VQ_LOW } rc_view_quality_t;
typedef enum { VW_NARROW, VW_NORMAL, VW_WIDE } rc_view_width_t;

rc_result_t analyze(char *p);

#endif /* __PARSER_H__ */

/* End of file included parser.h */
/* File parserdefs.h included by the generator c2ecl */

#ifndef __PARSERDEFS_H__
#define __PARSERDEFS_H__

#define ON_SEE(x) printf(\"See percept at time %i\\n\", x);
#define	ON_SEE_PLAYER(TEAMNAME, NUM, DIST, DIR, DISTCHG, DIRCHG, BODYDIR, HEADDIR) printf(\"See player %s %i at (%f, %f, %f, %f, %f, %f)\\n\", TEAMNAME, NUM, DIST, DIR, DISTCHG, DIRCHG, BODYDIR, HEADDIR);
#define ON_SEE_GOAL(SIDE, DIST, DIR) printf(\"See goal %c at (%f, %f)\\n\", SIDE, DIST, DIR);
#define ON_SEE_LINE(SIDE, DIST, DIR) printf(\"See line %c at (%f, %f)\\n\", SIDE, DIST, DIR);
#define ON_SEE_FLAG(T1, T2, T3, DIST, DIR, DISTCHG, DIRCHG) printf(\"See flag (%c, %c, %c) at (%f, %f, %f, %f)\\n\", T1, T2, T3, DIST, DIR, DISTCHG, DIRCHG);
#define ON_SEE_BALL(DIST, DIR, DISTCHG, DIRCHG) printf(\"See ball at (%f, %f, %f, %f)\\n\", DIST, DIR, DISTCHG, DIRCHG);

#define ON_HEAR(TIME, DIR, MSG) printf(\"Hear at time %i from %f %s\\n\", TIME, DIR, MSG);
#define ON_REFEREE(TIME, STATE, SIDE, NUM) printf(\"Referee say %i at time %i side is %c and num %i\\n\", STATE, TIME, SIDE, NUM);

#define ON_SENSE_BODY(TIME, QUALITY, VIEWWIDTH, STAMINA, EFFORT, SPEED, HEADDIR, KICKCOUNT, DASHCOUNT, TURNCOUNT, SAYCOUNT, TURNNECKCOUNT) printf(\"Sense body at time %i are (%i, %i, %i, %i, %i, %f, %i, %i, %i, %i, %i)\\n\", TIME, QUALITY, VIEWWIDTH, STAMINA, EFFORT, SPEED, HEADDIR, KICKCOUNT, DASHCOUNT, TURNCOUNT, SAYCOUNT, TURNNECKCOUNT);

#endif /* __PARSERDEFS_H__ */


/* End of file included parserdefs.h */
rc_result_t analyze(char *p) {
  char *input = p;
  rc_obj_t objname;
  int i, time, num;
  char teamname[MAX_TEAMNAME_LEN], labels[3];
  float dist, dir, distchg, dirchg, bodydir, headdir;
  rc_state_t state;
  char msg[MAX_MSG_LEN];
  rc_view_quality_t viewQuality;
  rc_view_width_t viewWidth;
  int stamina, effort, speed, kickCount, dashCount, turnCount, 
      sayCount, turnNeckCount;

  switch (input[3]) {
  case 'e': /* see */
    input += 5;

    READ_INT(time);

    ON_SEE(time);

    while (*input != ')') { /* Read the object info */
      labels[0] = labels[1] = labels[2] = '\\0';
      dist = dir = distchg = dirchg = bodydir = headdir = INVALID_VALUE;

      input += 3; /* eat \" ((\" */

      switch (*input) {
      case 'p': /* player */
	objname = OBJ_PLAYER;
	input += 6;

	num = INVALID_VALUE;
	teamname[0] = '\\0';

	if (*input++ == ')')
	  break;

	i = 0;
	while (!isspace(*input) && (*input != ')')) ++i, ++input;

	strncpy(teamname, input - i, i);

	teamname[i] = '\\0';

	if (*input++ == ')')
	  break;

	READ_INT(num);
	break;
      case 'g': /* goal */
	objname = OBJ_GOAL;
	labels[0] = input[5];

	input += 7;
	break;
      case 'b': /* ball */
	objname = OBJ_BALL;
	input += 5;
	break;
      case 'f': /* flag */
	objname = OBJ_FLAG;
	input += 5;

	labels[0] = *input++;

	if (*input++ == ')')
	  break;

	labels[1] = *input++;

	if (*input++ == ')')
	  break;

	labels[2] = *input++;

	if (*input == ')')
	  ++input;
	else
	  input += 2;
	break;
      case 'l': /* line */
	objname = OBJ_LINE;
	labels[0] = input[5];

	input += 7;
	break;
      }

      if (*input != ')') {
	++input;
      
	READ_NUM(dist);

	if (*input != ')') {
	  ++input;

	  READ_NUM(dir);
	  
	  if (*input != ')') {
	    ++input;
	    
	    READ_NUM(distchg);
	    
	    if (*input != ')') {
	      ++input;

	      READ_NUM(dirchg);
	      
	      if (*input != ')') {
		++input;

		READ_NUM(bodydir);

		if (*input != ')') {
		  ++input;

		  READ_NUM(headdir);
		}
	      }
	    }
	  }
	}
      }

      ++input;

      switch (objname) {
      case OBJ_PLAYER:
	ON_SEE_PLAYER(teamname, num, dist, dir, distchg, dirchg, bodydir, headdir);
	break;
      case OBJ_GOAL:
	ON_SEE_GOAL(labels[0], dist, dir);
	break;
      case OBJ_BALL:
	ON_SEE_BALL(dist, dir, distchg, dirchg);
	break;
      case OBJ_FLAG:
	ON_SEE_FLAG(labels[0], labels[1], labels[2], dist, dir, distchg, dirchg);
	break;
      case OBJ_LINE:
	ON_SEE_LINE(labels[0], dist, dir);
	break;
      }
    }
    break;
  case 'a': /* hear */
    input += 6;

    READ_INT(time);

    ++input; /* white space */

    switch (*input) {
    case 's':
      dir = SELF_DIR;
      input += 5;
      break;
    case 'r':
      dir = REFEREE_DIR;
      input += 8;
      break;
    default:
      READ_NUM(dir);
      ++input;
    }

    if (dir == REFEREE_DIR) {
      labels[0] = '\\0';
      num = -1;

      switch (*input) {
      case 'b': /* before_kick_off */
	state = S_BEFORE_KICK_OFF;
	break;
      case 'k': /* kick_* */
	if (input[5] == 'i') {
	  state = S_KICK_IN;
	  labels[0] = input[8];
	} else {
	  state = S_KICK_OFF;
	  labels[0] = input[9];
	}
	break;
      case 'c': /* corner_kick */
	state = S_CORNER_KICK;
	labels[0] = input[12];
	break;
      case 'o': /* offside */
	state = S_OFFSIDE;
	labels[0] = input[8];
	break;
      case 'g': /* goal_* */
	if (input[5] == 'k') {
	  state = S_GOAL_KICK;
	  labels[0] = input[10];
	} else {
	  state = S_GOAL;
	  labels[0] = input[5];
	  input += 7;
	  READ_INT(num);
	}
	break;
      case 'f': /* f* */
	if (input[1] == 'r') {
	  state = S_FREE_KICK;
	  labels[0] = input[10];
	} else {
	  state = S_FOUL;
	  labels[0] = input[5];
	  input += 7;
	  READ_INT(num);
	}
	break;
      case 'p': /* play_on */
	state = S_PLAY_ON;
	break;
      case 'h': /* half_time */
	state = S_HALF_TIME;
	break;
      case 't': /* time_up */
	state = S_TIME_UP;
	break;
      case 'e': /* extend */
	state = S_EXTEND;
	break;
      default:
	state = S_UNKNOWN;
      }

      ON_REFEREE(time, state, labels[0], num);
    } else {
      strcpy(msg, input);
      msg[strlen(msg) - 1] = '\\0';

      ON_HEAR(time, dir, msg);
    }
    break;
  case 'n': /* sense_body */
    input += 12;

    READ_INT(time);

    ++input; /* white space */

    /* view_mode */
    input += 11;

    switch (*input) {
    case 'h':
      viewQuality = VQ_HIGH;
      input += 5;
      break;
    case 'l':
      viewQuality = VQ_LOW;
      input += 4;
      break;
    }

    switch (input[1]) {
    case 'a':
      viewWidth = VW_NARROW;
      input += 7;
      break;
    case 'o':
      viewWidth = VW_NORMAL;
      input += 7;
      break;
    case 'i':
      viewWidth = VW_WIDE;
      input += 5;
      break;
    }

    /* stamina */
    input += 10;

    READ_INT(stamina);

    ++input;

    READ_INT(effort);

    ++input;

    /* speed */
    input += 8;

    READ_INT(speed);

    ++input;

    /* head_angle */
    input += 13;
    
    READ_NUM(headdir);

    ++input;

    /* kick */
    input += 7;

    READ_INT(kickCount);

    ++input;

    /* dash */
    input += 7;

    READ_INT(dashCount);

    ++input;

    /* turn */
    input += 7;

    READ_INT(turnCount);

    ++input;

    /* say */
    input += 6;

    READ_INT(sayCount);

    ++input;

    /* turn_neck */
    input += 12;

    READ_INT(turnNeckCount);

    ++input;

    ON_SENSE_BODY(time, viewQuality, viewWidth, stamina, effort, speed, headdir, kickCount, dashCount, turnCount, sayCount, turnNeckCount);
    break;
  }

  return OK;
}


")
