;;;; 
;;;; Last update: 9/1/1999
;;;; @author Antonio Cisternino
;;;; @version 0.1
;;;;
;;;; Purpose: Constants used
;;;;
;;;; Changes:
;;;;

;;; Constants
(defconstant *hst-sz* 10)
(defconstant *buf-sz* 10)

;;; Dimensions of the field (taken from the C code)
(defconstant pitch-length 105.0)
(defconstant half-pitch-length 52.5)
(defconstant pitch-width 68.0)
(defconstant half-pitch-width 34.0)
(defconstant pitch-margin 5.0)
(defconstant center-circle-r 9.15)
(defconstant penalty-area-length 16.5)
(defconstant penalty-area-width 40.32)
(defconstant half-penalty-area-width 20.16)
(defconstant goal-area-length 5.5)
(defconstant goal-area-with 18.32)
(defconstant goal-width 7.32)
(defconstant goal-depth 2.44)
(defconstant penalty-spot-dist 11.0)
(defconstant corner-arc-r 1.0)
(defconstant kick-off-clear-distance center-circle-r)

(defconstant *ball-decay* 0.94)

;;; Defines the flags positions
(defconstant flag-p-l-t-pos
  `(,(- penalty-area-length half-pitch-length) ,(- 0 half-penalty-area-width)))

(defconstant flag-p-l-c-pos
  `(,(- penalty-area-length half-pitch-length) 0))

(defconstant flag-p-l-b-pos
  `(,(- penalty-area-length half-pitch-length) ,half-penalty-area-width))

(defconstant flag-p-r-t-pos
  `(,(- half-pitch-length penalty-area-length) ,(- 0 half-penalty-area-width)))

(defconstant flag-p-r-c-pos
  `(,(- half-pitch-length penalty-area-length) 0))

(defconstant flag-p-l-b-pos
  `(,(- half-pitch-length penalty-area-length) ,half-penalty-area-width))

(defconstant flag-l-t-pos
  `(,(- 0 half-pitch-length) ,(- 0 half-pitch-width)))

(defconstant flag-l-b-pos
  `(,(- 0 half-pitch-length) ,half-pitch-width))

(defconstant flag-c-t-pos
  `(0 ,(- 0 half-pitch-width)))

(defconstant flag-c-b-pos
  `(0 ,half-pitch-width))

(defconstant flag-r-t-pos
  `(,half-pitch-length ,(- 0 half-pitch-width)))

(defconstant flag-r-b-pos
  `(,half-pitch-length ,half-pitch-width))

;;; Directions of the player
(defconstant *n* 0)
(defconstant *ne* 1)
(defconstant *e* 2)
(defconstant *se* 3)
(defconstant *s* 4)
(defconstant *sw* 5)
(defconstant *w* 6)
(defconstant *nw* 7)

;;; Conversion
(defconstant *sz-unit* 8)
(defconstant *nth-pitch-length* (/ pitch-length *sz-unit*))
(defconstant *nth-pitch-width* (/ pitch-width *sz-unit*))
