;;; Turn off the GC messages
(setf system:*gc-verbose* nil)

;;; Where libraries are stored
(defconstant *robocup-lib* "/home/cisterni/RoboCup/teams/IALP/lib")
(defconstant *ialp-dir-root* "..")
(defconstant *ialp-dir-plans* "../plans")

;;; Load the base library
(load (format nil "~A/~A" *robocup-lib* "robocup-2.0.o"))

;;; Functions to load the various modules needed
(defun ialp-load (file)
  "Load a file from the IALP root directory"
  (generic-loader *ialp-dir-root* file))

(defun ialp-load-plan (file)
  "Load a file from the IALP plans directory"
  (generic-loader *ialp-dir-plans* file))

;;; The following code load all needed files exluded the
;;; last one that distinguish among goalie and a normal player
(ialp-load "layer")
(ialp-load "constants")
(ialp-load "struct")
(ialp-load "macros")
(ialp-load "agent-kb")
(ialp-load "predicates")
(ialp-load "functions")
(ialp-load "calc-pos")
(ialp-load "plans/def-top-layer")
(ialp-load "plans/def-handlers")
(ialp-load "ialp-player")
