(defun play-on-handler (kb)
  (if (have-ball? kb)
      (if (can-kick? kb)
	  (if (and (see-enemy-goal? kb)
		   (< (second (agent-kb-enemy-goal kb)) 15))
	      '((kick! 100))

	    ;; Good! I have the ball: and now?
	    (let* ((cand (pass-candidates kb))
		   (pl (select-candidate kb cand)))

	      (if pl ; Ok, I can pass the ball :O
		  `((pass-ball ,pl)
		    (stay-in-zone ,*zone* ,(normal)))
		;; Uh-oh, I cannot pass the ball... :(
		'((handle-with-ball)))))
	;; I'm not at ball: go ball!
	`((go-ball ,(very-fast))))
    
    ;; Ok, stay in your zone C|B/
    (if (not (in-zone? kb *zone*))
	`((stay-in-zone ,*zone* ,(very-fast)))
      (if (and
	   (ball-in-zone? kb *zone*)
	   (can-go-ball? kb))
	  `((go-ball ,(very-fast)))
	'((see-ball))))))

(defun kick-off-handler (kb)
  `((*while* (> (abs (- ,*start-dir* (pos-dir (agent-kb-player-pos ,kb)))) 10) ((turn 7)))
    (*while* t ((sleep)))))    

(defun goal-handler (kb)
  `((sleep)
    (move ,*start-x* ,*start-y*)
    (sleep)
    (sleep)
    ,(if (eq (second (agent-kb-last-referee-msg kb)) 'my)
	 '(*while* t ((turn 90)))
       '(*while* t ((sleep)))))) ; Is interrupted by the change state

(defun free-kick-handler (kb)
  (if (eq (second (referee kb)) 'my)
      (if (ball-in-zone? kb *zone*)
	  '((free-kick))
	(if (not (in-zone? kb *zone*))
	    `((stay-in-zone ,*zone* ,(normal-slow)))
	  '((sleep))))
    (if (not (in-zone? kb *zone*))
	`((stay-in-zone ,*zone* ,(normal-slow)))
      '((sleep)))))

(defun kick-in-handler (kb)
  (if (eq (second (referee kb)) 'my)
      (if (ball-in-zone? kb *zone*)
	  '((free-kick))
	(if (not (in-zone? kb *zone*))
	    `((stay-in-zone ,*zone* ,(normal-slow)))
	  '((sleep))))
    (if (not (in-zone? kb *zone*))
	`((stay-in-zone ,*zone* ,(normal-slow)))
      '((sleep)))))

(defun default-handler (kb)
  '((sleep)))
