;;;; top-layer.lsp
;;;;
;;;; Last update: 3/1/1999
;;;; @author Antonio Cisternino
;;;; @version -
;;;; 
;;;; Purpose: top layer to test players

;;; These constants must be redefined in all files
; (defconstant *start-x* -35)
; (defconstant *start-y* -25)
; (defconstant *start-dir* 0)
; (defconstant *zone* '(0 0 2 3))
; (defconstant *pass-empathy*
;   #( 0 0.1 0.2 0.2 0.2 0.4 0.4 0.7 0.7 0.7 0.5 0.5 ))

(defconstant *max-ball-age* 5)
(defconstant *max-player-age* 10)
(defconstant *near-ball* 2)
(defconstant *kick-dist* 1)

;; Pass constants
(defconstant *alpha-pass* 1)
(defconstant *beta-no-pass* 0.5)
(defconstant *pass-thresold* 0)
(defconstant *pass-ideal-distance* 20)

(si:allocate 'STRING 90 t)
(si:allocate 'SYMBOL 90 t)
(si:allocate 'CONS   250 t)
(si:allocate 'SHORT-FLOAT 10 t)
(si:allocate-contiguous-pages 130 t)
(si:allocate-relocatable-pages 90)

;;; Defines the main strategy of the player
(defun top-level-decision (p)
  (let ((kb (ialp-player-kb p)))
    (cond
     ((referee-msg-is? kb 'PLAY-ON)
      (play-on-handler kb))

     ((referee-msg-is? kb 'KICK-OFF)
      (kick-off-handler kb))

     ((referee-msg-is? kb 'GOAL)
      (goal-handler kb))

     ((referee-msg-is? kb 'FREE-KICK)
      (free-kick-handler kb))

     ((referee-msg-is? kb 'KICK-IN)
      (kick-in-handler kb))

     (t
      (default-handler kb)))))
