(defconstant *start-dir* 0)
(defconstant *catch-dist* 1)
(defconstant *goalie-x* (+ (- 0 half-pitch-length) 3))
(defconstant *goalie-y* 0)
(defconstant *goalie-catch-distance* 15)
(defconstant *start-x* *goalie-x*)
(defconstant *start-y* *goalie-y*)
(defconstant *zone* '(0 2 2 4))
(defconstant *max-ball-age* 10)
(defconstant *pass-empathy*
  #( 0 0.1 0.5 0.5 0.5 0.6 0.6 0.4 0.4 0.4 0.3 0.3 ))

(defun play-on-handler (kb)
(when (and (agent-kb-goalie-fire kb) (see-ball? kb))
  (format t "Ball is ~A~%" (last-see-ball kb)))
  (if (and (not (agent-kb-goalie-fire kb)) (can-catch? kb))
      '((catch-ball))
    (progn
      (when (and
	     (agent-kb-goalie-fire kb)
	     (not (and
		   (see-ball? kb)
		   (obj-info-v (last-see-ball kb))
		   (> 0 (obj-info-v (last-see-ball kb))))))
	(setf (agent-kb-goalie-fire kb) nil))
      (if (not (goalie-in-place? kb))
	  '((in-place))
	'((follow-action))))))

(defun free-kick-handler (kb)
  (if (and (eq (second (referee kb)) 'my) (can-kick? kb))
      (progn
	(setf (agent-kb-goalie-fire kb) t)
	`((sleep) (sleep)
	  (move ,(- 4 half-pitch-length) 0)
	  (sleep) (sleep)
	  (*while* (not (see-enemy-goal? ,kb)) ((turn 45) (sleep)))
	  (launch-ball)))
    '((sleep))))

(defun default-handler (kb)
  `((*while* (not (goalie-in-place? ,kb)) ((in-place))) 
    (*while* (not (see-ball? ,kb)) ((see-ball)))
    (*while* t ((sleep)))))

