;;; @author Antonio Cisternino
;;; @version 0.1
;;;
;;;
;;; Changes:
;;;

(eval-when (compile eval)
 (plan-file "individual"))

(def-empty-update)

(defactions
  (action-list stay-in-zone)
  (action-list handle-with-ball)
  (action-list free-kick))

(defaction stay-in-zone (zone speed)
  "Usage: stay-in-zone (x y).
x and y individuates 1/nth of field"
  (let ((x (first zone))
	(y (second zone))
	(w (third zone))
	(h (fourth zone)))
    (if (in-zone? kb zone)
	'((sleep))
      `((goto ,(gen-pos-x kb x w) ,(gen-pos-y kb y h) ,speed)))))

;; SISTEMARE LA FUNZIONE
(defaction handle-with-ball ()
  (if (> (abs (pos-dir (agent-kb-player-pos kb))) 90)
      (if (< (pos-dir (agent-kb-player-pos kb)) 0)
	  '((turn-ball R))
	'((turn-ball L)))
    (if (< (second (agent-kb-enemy-goal kb)) 15)
	'((kick! 100))
      (let ((speed (fast))
	    (allungo (- 1 (* (random 5) 0.08))))
	`((see-enemy-goal) (run-with-ball ,speed 0 ,allungo))))))

;; Vai a posto o smarcati per prendere la palla.
(defaction free-kick ()
  (if (not (can-kick? kb))
      `((go-ball ,(normal-slow)))
    (let* ((cand (pass-candidates kb))
	   (p (select-candidate kb cand)))
      (if p
	  `((pass-ball ,p))
	`((run-with-ball ,(slow) 0 1))))))